<?php
namespace Geral\Repositories;

class Inscrestad extends \Doctrine\ORM\EntityRepository
{
    public function opInEst($cdfilial, $cdforneced, $cdcliente, $cdinscesta, $cdempresa, $nrorg){
        $sql = <<<SQL
            SELECT INSC.SGESTADO
                FROM
                (SELECT SGESTADO
                   FROM ENDEFORN
                  WHERE IDTPENDEFORN = 'P'
                    AND CDFORNECED = (SELECT CDFORNECED FROM FORNECEDOR WHERE CDFORNECED = :P_CDFORNECED)

                 UNION ALL

                 SELECT SGESTADO
                   FROM ENDECLIE
                  WHERE IDTPENDECLIE = 'P'
                    AND CDCLIENTE = (SELECT CDCLIENTE FROM CLIENTE WHERE CDCLIENTE = :P_CDCLIENTE)

                 UNION ALL

                 SELECT SGESTADO
                   FROM ENDEFILI
                  WHERE IDTPENDEFILI = 'P'
                    AND CDFILIAL = :P_CDFILIAL
                 ) ORIG,

                (SELECT SGESTADO
                  FROM INSCRESTAD
                 WHERE CDINSCESTA = :P_CDINSCESTA
                   AND CDEMPRESA  = :P_CDEMPRESA
                   AND NRORG      = :P_NRORG) INSC

                WHERE ORIG.SGESTADO = INSC.SGESTADO
SQL;

        $params = array(
            'P_CDFORNECED'      => $cdforneced,
            'P_CDCLIENTE'   => $cdcliente,
            'P_CDFILIAL'   => $cdfilial,
            'P_CDINSCESTA'   => $cdinscesta,
            'P_CDEMPRESA'      => $cdempresa,
            'P_NRORG'      => $nrorg
        );

        return $this->getEntityManager()->getConnection()->fetchColumn($sql, $params);
    }

    public function getMaxCdempresaPorNrorg($nrorg){
      $query = "SELECT MAX(TO_NUMBER(CDEMPRESA))+1 AS CDEMPRESA FROM SA_INSCRESTAD WHERE NRORG = :nrorg";
      $param = array("nrorg" => $nrorg);
      $result = $this->getEntityManager()->getConnection()->fetchAll($query, $param);
      return empty($result[0]['CDEMPRESA']) ? 1 : $result[0]['CDEMPRESA'];
    }
}