/******************************************************************************************/
/******************************************************************************************/
/*                                                                                                                                                                                */
/* Trigger: DTULTATU_CCUSCLIE                                                                                                                                */
/* Tabela : CCUSCLIE                                                                                                                                                  */
/*                                                                                                                                                                                */
/* Criao:                                                                                                                                                                  */
/* 29/09/2005 - Wanderson Aloisio                                                                                                                          */
/*                                                                                                                                                                                */
/******************************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_CCUSCLIE
BEFORE INSERT OR UPDATE OR DELETE
ON CCUSCLIE FOR EACH ROW
BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCUSC := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDCLIENTE,0) <> NVL(:NEW.CDCLIENTE,0)) OR
         (NVL(:OLD.CDCCUSCLIE,0) <> NVL(:NEW.CDCCUSCLIE,0)) OR 
         (NVL(:OLD.NMCCUSCLIE,0) <> NVL(:NEW.NMCCUSCLIE,0)) THEN
         :NEW.DTULTATUCUSC := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CCUSCLIE', '', 'CDCLIENTE='||:OLD.CDCLIENTE||';CDCCUSCLIE='||:OLD.CDCCUSCLIE||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE CCUSCLIE MODIFY DTULTATUCUSC DEFAULT SYSDATE
/


-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_CCUSCLIE','4.07.037'); END;
/

