IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_GOP_APROVAORCAOP' AND
                 TYPE   = 'TR'                AND
                 U.UID  = O.UID               AND
                 U.NAME = USER)
DROP TRIGGER LOG_GOP_APROVAORCAOP
GO

CREATE TRIGGER LOG_GOP_APROVAORCAOP
ON APROVAORCAOP
FOR DELETE, INSERT, UPDATE
AS

   DECLARE @V_USUARIO        VARCHAR(40);
   DECLARE @V_TIPO           VARCHAR(1);
   DECLARE @V_ITPESQ         VARCHAR(40);
   DECLARE @V_DESC           VARCHAR(300);
   DECLARE @V_DTOPER         DATETIME;

/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE @V_ID_COMANDO          VARCHAR(1);

   DECLARE @V_OLD_NRANOORCAOP     VARCHAR(4);
   DECLARE @V_OLD_CDFILIAL        VARCHAR(4);
   DECLARE @V_OLD_CDOPERADOR      VARCHAR(12);
   DECLARE @V_OLD_IDCALCULOOP     VARCHAR(1);
   DECLARE @V_OLD_IDAPROVACAOOP   VARCHAR(1);
   DECLARE @V_OLD_IDAPROVAORCAFAT VARCHAR(1);
   DECLARE @V_OLD_IDAPROVAORCFLIQ VARCHAR(1);
   DECLARE @V_OLD_IDAPROVAORCCONS VARCHAR(1);
   DECLARE @V_OLD_IDAPROVAORCMOB  VARCHAR(1);
   DECLARE @V_OLD_IDAPROVAORCDMAT VARCHAR(1);
   DECLARE @V_OLD_IDAPROVAORCDDIV VARCHAR(1);
   DECLARE @V_OLD_IDAPROVAORCDLE  VARCHAR(1);
   DECLARE @V_OLD_CDVERSORCAOP    NUMERIC;
   
   
   DECLARE @V_NEW_NRANOORCAOP     VARCHAR(4);
   DECLARE @V_NEW_CDFILIAL        VARCHAR(4);
   DECLARE @V_NEW_CDOPERADOR      VARCHAR(12);
   DECLARE @V_NEW_IDCALCULOOP     VARCHAR(1);
   DECLARE @V_NEW_IDAPROVACAOOP   VARCHAR(1);
   DECLARE @V_NEW_IDAPROVAORCAFAT VARCHAR(1);
   DECLARE @V_NEW_IDAPROVAORCFLIQ VARCHAR(1);
   DECLARE @V_NEW_IDAPROVAORCCONS VARCHAR(1);
   DECLARE @V_NEW_IDAPROVAORCMOB  VARCHAR(1);
   DECLARE @V_NEW_IDAPROVAORCDMAT VARCHAR(1);
   DECLARE @V_NEW_IDAPROVAORCDDIV VARCHAR(1);
   DECLARE @V_NEW_IDAPROVAORCDLE  VARCHAR(1);
   DECLARE @V_NEW_CDVERSORCAOP    NUMERIC;

BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';

   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
      SELECT
         'D' IDCOMANDO,
		 NRANOORCAOP,
		 CDFILIAL,
		 CDOPERADOR,
		 IDCALCULOOP,
		 IDAPROVACAOOP,
		 IDAPROVAORCAFAT,
		 IDAPROVAORCFLIQ,
		 IDAPROVAORCCONS,
		 IDAPROVAORCMOB,
		 IDAPROVAORCDMAT,
		 IDAPROVAORCDDIV,
		 IDAPROVAORCDLE,
		 CDVERSORCAOP,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL
      FROM
         DELETED
      WHERE
         NRANOORCAOP+CDFILIAL+CDOPERADOR+CDVERSORCAOP NOT IN (SELECT NRANOORCAOP+CDFILIAL+CDOPERADOR+CDVERSORCAOP FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,
		 DELETED.NRANOORCAOP,
		 DELETED.CDFILIAL,
		 DELETED.CDOPERADOR,
		 DELETED.IDCALCULOOP,
		 DELETED.IDAPROVACAOOP,
		 DELETED.IDAPROVAORCAFAT,
		 DELETED.IDAPROVAORCFLIQ,
		 DELETED.IDAPROVAORCCONS,
		 DELETED.IDAPROVAORCMOB,
		 DELETED.IDAPROVAORCDMAT,
		 DELETED.IDAPROVAORCDDIV,
		 DELETED.IDAPROVAORCDLE,
		 DELETED.CDVERSORCAOP,
		 INSERTED.NRANOORCAOP,
		 INSERTED.CDFILIAL,
		 INSERTED.CDOPERADOR,
		 INSERTED.IDCALCULOOP,
		 INSERTED.IDAPROVACAOOP,
		 INSERTED.IDAPROVAORCAFAT,
		 INSERTED.IDAPROVAORCFLIQ,
		 INSERTED.IDAPROVAORCCONS,
		 INSERTED.IDAPROVAORCMOB,
		 INSERTED.IDAPROVAORCDMAT,
		 INSERTED.IDAPROVAORCDDIV,
		 INSERTED.IDAPROVAORCDLE,
		 INSERTED.CDVERSORCAOP
      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.NRANOORCAOP  = DELETED.NRANOORCAOP    AND
         INSERTED.CDFILIAL = DELETED.CDFILIAL           AND
         INSERTED.CDOPERADOR = DELETED.CDOPERADOR       AND
         INSERTED.CDVERSORCAOP = DELETED.CDVERSORCAOP 

      UNION ALL

      SELECT
         'I' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
		 NRANOORCAOP,
		 CDFILIAL,
		 CDOPERADOR,
		 IDCALCULOOP,
		 IDAPROVACAOOP,
		 IDAPROVAORCAFAT,
		 IDAPROVAORCFLIQ,
		 IDAPROVAORCCONS,
		 IDAPROVAORCMOB,
		 IDAPROVAORCDMAT,
		 IDAPROVAORCDDIV,
		 IDAPROVAORCDLE,
		 CDVERSORCAOP
      FROM
         INSERTED
      WHERE
         NRANOORCAOP+CDFILIAL+CDOPERADOR+CDVERSORCAOP NOT IN (SELECT NRANOORCAOP+CDFILIAL+CDOPERADOR+CDVERSORCAOP FROM DELETED);

      OPEN C_CURSOR;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
									@V_OLD_NRANOORCAOP,
									@V_OLD_CDFILIAL,
									@V_OLD_CDOPERADOR,
									@V_OLD_IDCALCULOOP,
									@V_OLD_IDAPROVACAOOP,
									@V_OLD_IDAPROVAORCAFAT,
									@V_OLD_IDAPROVAORCFLIQ,
									@V_OLD_IDAPROVAORCCONS,
									@V_OLD_IDAPROVAORCMOB,
									@V_OLD_IDAPROVAORCDMAT,
									@V_OLD_IDAPROVAORCDDIV,
									@V_OLD_IDAPROVAORCDLE,
									@V_OLD_CDVERSORCAOP,

									@V_NEW_NRANOORCAOP,
									@V_NEW_CDFILIAL,
									@V_NEW_CDOPERADOR,
									@V_NEW_IDCALCULOOP,
									@V_NEW_IDAPROVACAOOP,
									@V_NEW_IDAPROVAORCAFAT,
									@V_NEW_IDAPROVAORCFLIQ,
									@V_NEW_IDAPROVAORCCONS,
									@V_NEW_IDAPROVAORCMOB,
									@V_NEW_IDAPROVAORCDMAT,
									@V_NEW_IDAPROVAORCDDIV,
									@V_NEW_IDAPROVAORCDLE,
									@V_NEW_CDVERSORCAOP;


   WHILE (@@FETCH_STATUS = 0) BEGIN
      SET @V_DESC = '';
      IF @V_ID_COMANDO = 'D' BEGIN
         IF @V_OLD_NRANOORCAOP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'AnoOrc=' + @V_OLD_NRANOORCAOP;
         END;

         IF @V_OLD_CDFILIAL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Filial=' + @V_OLD_CDFILIAL;
         END;

         IF @V_OLD_CDOPERADOR IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdOper=' + @V_OLD_CDOPERADOR;
         END;

         IF @V_OLD_IDCALCULOOP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdCalcOp=' + @V_OLD_IDCALCULOOP;
         END;

         IF @V_OLD_IDAPROVACAOOP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdAprovOp=' + @V_OLD_IDAPROVACAOOP;
         END;

         IF @V_OLD_IDAPROVAORCAFAT IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdApOrFat=' + @V_OLD_IDAPROVAORCAFAT;
         END;

         IF @V_OLD_IDAPROVAORCFLIQ IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdApOrFLiq=' + @V_OLD_IDAPROVAORCFLIQ;
         END;

         IF @V_OLD_IDAPROVAORCCONS IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdAprOrcCons=' + @V_OLD_IDAPROVAORCCONS;
         END;

         IF @V_OLD_IDAPROVAORCMOB IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdAprOrcMob=' + @V_OLD_IDAPROVAORCMOB;
         END;

         IF @V_OLD_IDAPROVAORCDMAT IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdAprovCDMat=' + @V_OLD_IDAPROVAORCDMAT;
         END;

         IF @V_OLD_IDAPROVAORCDDIV IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdAprovOrcDDiv=' + @V_OLD_IDAPROVAORCDDIV;
         END;

         IF @V_OLD_IDAPROVAORCDLE IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdAproOrcDLE=' + @V_OLD_IDAPROVAORCDLE;
         END;

         IF @V_OLD_CDVERSORCAOP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdVersao=' + @V_OLD_CDVERSORCAOP;
         END;
         
         SET @V_TIPO     = '3';
         SET @V_ITPESQ   = @V_OLD_NRANOORCAOP+@V_OLD_CDFILIAL+@V_OLD_CDOPERADOR+@V_OLD_CDVERSORCAOP;
      END
      ELSE IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN
         IF (ISNULL(@V_OLD_NRANOORCAOP ,0)   <> ISNULL(@V_NEW_NRANOORCAOP,0))   OR
            (ISNULL(@V_OLD_CDFILIAL,' ') <> ISNULL(@V_NEW_CDFILIAL,' ')) OR
            (ISNULL(@V_OLD_CDOPERADOR  ,' ') <> ISNULL(@V_NEW_CDOPERADOR ,' ')) OR
            (ISNULL(@V_OLD_IDCALCULOOP  ,' ') <> ISNULL(@V_NEW_IDCALCULOOP ,' ')) OR
            (ISNULL(@V_OLD_IDAPROVACAOOP  ,' ') <> ISNULL(@V_NEW_IDAPROVACAOOP ,' ')) OR
            (ISNULL(@V_OLD_IDAPROVAORCAFAT  ,' ') <> ISNULL(@V_NEW_IDAPROVAORCAFAT ,' ')) OR
            (ISNULL(@V_OLD_IDAPROVAORCFLIQ  ,' ') <> ISNULL(@V_NEW_IDAPROVAORCFLIQ ,' ')) OR
            (ISNULL(@V_OLD_IDAPROVAORCCONS  ,' ') <> ISNULL(@V_NEW_IDAPROVAORCCONS ,' ')) OR
            (ISNULL(@V_OLD_IDAPROVAORCMOB  ,' ') <> ISNULL(@V_NEW_IDAPROVAORCMOB ,' ')) OR
            (ISNULL(@V_OLD_IDAPROVAORCDMAT  ,' ') <> ISNULL(@V_NEW_IDAPROVAORCDMAT ,' ')) OR
            (ISNULL(@V_OLD_IDAPROVAORCDDIV  ,' ') <> ISNULL(@V_NEW_IDAPROVAORCDDIV ,' ')) OR
            (ISNULL(@V_OLD_IDAPROVAORCDLE  ,' ') <> ISNULL(@V_NEW_IDAPROVAORCDLE ,' ')) OR
            (ISNULL(@V_OLD_CDVERSORCAOP  ,' ') <> ISNULL(@V_NEW_CDVERSORCAOP ,' '))  BEGIN


            IF (ISNULL(@V_OLD_NRANOORCAOP ,0)   <> ISNULL(@V_NEW_NRANOORCAOP,0))BEGIN
               SET @V_DESC = @V_DESC + 'Ano=' + @V_NEW_NRANOORCAOP;
            END;

            IF (ISNULL(@V_OLD_CDFILIAL,' ') <> ISNULL(@V_NEW_CDFILIAL,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' Filial=' + @V_NEW_CDFILIAL;
            END;

            IF (ISNULL(@V_OLD_CDOPERADOR  ,' ') <> ISNULL(@V_NEW_CDOPERADOR ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' CdOper=' + @V_NEW_CDOPERADOR;
            END;

            IF (ISNULL(@V_OLD_IDCALCULOOP  ,' ') <> ISNULL(@V_NEW_IDCALCULOOP ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' IdCalcOp=' + @V_NEW_IDCALCULOOP;
            END;

            IF (ISNULL(@V_OLD_IDAPROVACAOOP  ,' ') <> ISNULL(@V_NEW_IDAPROVACAOOP ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' IdAprovOp=' + @V_NEW_IDAPROVACAOOP;
            END;

            IF (ISNULL(@V_OLD_IDAPROVAORCAFAT  ,' ') <> ISNULL(@V_NEW_IDAPROVAORCAFAT ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' IdAprOrcFat=' + @V_NEW_IDAPROVAORCAFAT;
            END;

            IF (ISNULL(@V_OLD_IDAPROVAORCFLIQ  ,' ') <> ISNULL(@V_NEW_IDAPROVAORCFLIQ ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' IdAprOrcFLiq=' + @V_NEW_IDAPROVAORCFLIQ;
            END;

            IF (ISNULL(@V_OLD_IDAPROVAORCCONS  ,' ') <> ISNULL(@V_NEW_IDAPROVAORCCONS ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' IdAprOrcCons=' + @V_NEW_IDAPROVAORCCONS;
            END;

            IF (ISNULL(@V_OLD_IDAPROVAORCMOB  ,' ') <> ISNULL(@V_NEW_IDAPROVAORCMOB ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' IdAprOrcMob=' + @V_NEW_IDAPROVAORCMOB;
            END;

            IF (ISNULL(@V_OLD_IDAPROVAORCDMAT  ,' ') <> ISNULL(@V_NEW_IDAPROVAORCDMAT ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' IdAprOrcDMat=' + @V_NEW_IDAPROVAORCDMAT;
            END;

            IF (ISNULL(@V_OLD_IDAPROVAORCDDIV  ,' ') <> ISNULL(@V_NEW_IDAPROVAORCDDIV ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' IdAprOrcDDiv=' + @V_NEW_IDAPROVAORCDDIV;
            END;

            IF (ISNULL(@V_OLD_IDAPROVAORCDLE  ,' ') <> ISNULL(@V_NEW_IDAPROVAORCDLE ,' ')) BEGIN
               SET @V_DESC = @V_DESC + ' IdAprOrcDLE=' + @V_NEW_IDAPROVAORCDLE;
            END;

            IF (ISNULL(@V_OLD_CDVERSORCAOP  ,' ') <> ISNULL(@V_NEW_CDVERSORCAOP ,' '))BEGIN
               SET @V_DESC = @V_DESC + ' CdVersao=' + @V_NEW_CDVERSORCAOP;
            END;


            SET @V_TIPO    = '2';
            SET @V_ITPESQ  = @V_OLD_NRANOORCAOP+@V_OLD_CDFILIAL+@V_OLD_CDOPERADOR+@V_OLD_CDVERSORCAOP;
         END;
      END
      ELSE BEGIN
         SET @V_TIPO     = '1';
         SET @V_ITPESQ   = @V_OLD_NRANOORCAOP+@V_OLD_CDFILIAL+@V_OLD_CDOPERADOR+@V_OLD_CDVERSORCAOP;

         IF @V_NEW_NRANOORCAOP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'AnoOrc=' + @V_NEW_NRANOORCAOP;
         END;

         IF @V_NEW_CDFILIAL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Filial=' + @V_NEW_CDFILIAL;
         END;

         IF @V_NEW_CDOPERADOR IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdOper=' + @V_NEW_CDOPERADOR;
         END;

         IF @V_NEW_IDCALCULOOP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdCalcOp=' + @V_NEW_IDCALCULOOP;
         END;

         IF @V_NEW_IDAPROVACAOOP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdAprOp=' + @V_NEW_IDAPROVACAOOP;
         END;

         IF @V_NEW_IDAPROVAORCAFAT IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdAprOrcFat=' + @V_NEW_IDAPROVAORCAFAT;
         END;

         IF @V_NEW_IDAPROVAORCFLIQ IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdAprOrcFLiq=' + @V_NEW_IDAPROVAORCFLIQ;
         END;

         IF @V_NEW_IDAPROVAORCCONS IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdAprOrcCons=' + @V_NEW_IDAPROVAORCCONS;
         END;

         IF @V_NEW_IDAPROVAORCMOB IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdAprOrcMob=' + @V_NEW_IDAPROVAORCMOB;
         END;

         IF @V_NEW_IDAPROVAORCDMAT IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdAprOrcDMat=' + @V_NEW_IDAPROVAORCDMAT;
         END;

         IF @V_NEW_IDAPROVAORCDDIV IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdAprOrcDDiv=' + @V_NEW_IDAPROVAORCDDIV;
         END;

         IF @V_NEW_IDAPROVAORCDLE IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' IdAprOrcDLE=' + @V_NEW_IDAPROVAORCDLE;
         END;

         IF @V_NEW_CDVERSORCAOP IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CdVersao=' + @V_NEW_CDVERSORCAOP;
         END;
      END;

      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();
               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                  ('APROVAORCAOP',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO,  @V_ITPESQ, @V_DESC);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
									@V_OLD_NRANOORCAOP,
									@V_OLD_CDFILIAL,
									@V_OLD_CDOPERADOR,
									@V_OLD_IDCALCULOOP,
									@V_OLD_IDAPROVACAOOP,
									@V_OLD_IDAPROVAORCAFAT,
									@V_OLD_IDAPROVAORCFLIQ,
									@V_OLD_IDAPROVAORCCONS,
									@V_OLD_IDAPROVAORCMOB,
									@V_OLD_IDAPROVAORCDMAT,
									@V_OLD_IDAPROVAORCDDIV,
									@V_OLD_IDAPROVAORCDLE,
									@V_OLD_CDVERSORCAOP,

									@V_NEW_NRANOORCAOP,
									@V_NEW_CDFILIAL,
									@V_NEW_CDOPERADOR,
									@V_NEW_IDCALCULOOP,
									@V_NEW_IDAPROVACAOOP,
									@V_NEW_IDAPROVAORCAFAT,
									@V_NEW_IDAPROVAORCFLIQ,
									@V_NEW_IDAPROVAORCCONS,
									@V_NEW_IDAPROVAORCMOB,
									@V_NEW_IDAPROVAORCDMAT,
									@V_NEW_IDAPROVAORCDDIV,
									@V_NEW_IDAPROVAORCDLE,
									@V_NEW_CDVERSORCAOP;
   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_GOP_APROVAORCAOP','5.85.000';
GO
