CREATE OR REPLACE TRIGGER LOG_VND_ITEMPRECO
AFTER DELETE OR INSERT OR UPDATE
ON ITEMPRECO FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(4000);
  V_ITPESQ       VARCHAR2(60);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Inclusao, '2' - Alteracao, '3' - Exclusao*/
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   NMUSUARIO(V_NMOPERADOR);
   IF :NEW.IDORIGENDPOINT = 'S' THEN
      V_NMOPERADOR := 'ORIGEM ENDPOINT';
   END IF;
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);
   IF UPDATING THEN
		IF NVL(:NEW.CDFILIAL ,'NULL') <> NVL(:OLD.CDFILIAL ,'NULL') THEN
			V_DESC   := 'Filial ' || '' || NVL(:NEW.CDFILIAL,'');
		END IF;
		IF NVL(:NEW.CDTABEPREC ,'NULL') <> NVL(:OLD.CDTABEPREC ,'NULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Tab Preco ' || '' || NVL(:NEW.CDTABEPREC,'');
		END IF;
		IF NVL(:NEW.DTINIVGPREC ,TO_DATE('01/01/0001','DD/MM/YYYY')) <> NVL(:OLD.DTINIVGPREC ,TO_DATE('01/01/0001','DD/MM/YYYY')) THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Dt Ini Vg Preco ' || '' || NVL(:NEW.DTINIVGPREC,'');
		END IF;
		IF NVL(:NEW.CDPRODUTO ,'NULL') <> NVL(:OLD.CDPRODUTO ,'NULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Produto ' || '' || NVL(:NEW.CDPRODUTO,'');
		END IF;
		IF NVL(:NEW.CDPRPAITABPR ,'NULL') <> NVL(:OLD.CDPRPAITABPR ,'NULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Cd Pai TAB Preco ' || '' || NVL(:NEW.CDPRPAITABPR,'');
		END IF;
		IF NVL(:NEW.VRPRECITEM ,999999) <> NVL(:OLD.VRPRECITEM ,999999) THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Vr Preco Item ' || '' || NVL(:NEW.VRPRECITEM,'');
		END IF;
		IF NVL(:NEW.VRPRECITEMCL ,999999) <> NVL(:OLD.VRPRECITEMCL ,999999) THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Vr Preco Item Cli ' || '' || NVL(:NEW.VRPRECITEMCL,'');
		END IF;
		IF NVL(:NEW.VRPRECMAXITE ,999999) <> NVL(:OLD.VRPRECMAXITE ,999999) THEN	
			V_DESC := NVL(V_DESC,'') || ' ' || 'Vr Preco Max Item ' || '' || NVL(:NEW.VRPRECMAXITE,'');
		END IF;
		IF NVL(:NEW.IDPRECVARIA ,'NULL') <> NVL(:OLD.IDPRECVARIA ,'NULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Id Preco Variado ' || '' || NVL(:NEW.IDPRECVARIA,'');
		END IF;
		IF NVL(:NEW.VRPRESUGITEM ,999999) <> NVL(:OLD.VRPRESUGITEM ,999999) THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Vr Preco Sug Item ' || '' || NVL(:NEW.VRPRESUGITEM,'');
		END IF;
		IF NVL(:NEW.VRCUSTITEM ,999999) <> NVL(:OLD.VRCUSTITEM ,999999) THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Vr Custo Item ' || '' || NVL(:NEW.VRCUSTITEM,'');
		END IF;
		IF NVL(:NEW.VRMKUPITEM ,999999) <> NVL(:OLD.VRMKUPITEM ,999999) THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Vr Mkup Item ' || '' || NVL(:NEW.VRMKUPITEM,'');
		END IF;
		IF NVL(:NEW.IDPRODPROMOC ,'NULL') <> NVL(:OLD.IDPRODPROMOC ,'NULL') THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Id Prod Promocao ' || '' || NVL(:NEW.IDPRODPROMOC,'');
		END IF;
		IF NVL(:NEW.DTULTATUITPR ,TO_DATE('01/01/0001','DD/MM/YYYY')) <> NVL(:OLD.DTULTATUITPR ,TO_DATE('01/01/0001','DD/MM/YYYY')) THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Dt Ult Atu Item Prod ' || '' || NVL(:NEW.DTULTATUITPR,'');
		END IF;
      IF NVL(:NEW.VRPRECITEMDLV ,999999) <> NVL(:OLD.VRPRECITEMDLV ,999999) THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Vr Delivery ' || '' || NVL(:NEW.VRPRECITEMDLV,'');
		END IF;
      IF NVL(:NEW.VRPRECITEMCMD ,999999) <> NVL(:OLD.VRPRECITEMCMD ,999999) THEN
			V_DESC := NVL(V_DESC,'') || ' ' || 'Vr Comanda ' || '' || NVL(:NEW.VRPRECITEMCMD,'');
		END IF;    
    IF NVL(:NEW.IDEXIPRECOSITE, 'NULL') <> NVL(:OLD.IDEXIPRECOSITE, '') THEN
      V_DESC := NVL(V_DESC, '') || ' ' || 'Existe Preco Site ' || '' || NVL(:NEW.IDEXIPRECOSITE, '');
    END IF;
    IF NVL(:NEW.NMPRODUTOSITE, 'NULL') <> NVL(:OLD.NMPRODUTOSITE, '') THEN
      V_DESC := NVL(V_DESC, '') || ' ' || 'Produto Site ' || '' || NVL(:NEW.NMPRODUTOSITE, '');
    END IF;
    IF NVL(:NEW.HRINIVENPROD, 'NULL') <> NVL(:OLD.HRINIVENPROD, '') THEN
      V_DESC := NVL(V_DESC, '') || ' ' || 'Hr Ini. Vend. Prod. ' || '' || NVL(:NEW.HRINIVENPROD, '');
    END IF;
    IF NVL(:NEW.HRFIMVENPROD, 'NULL') <> NVL(:OLD.HRFIMVENPROD, '') THEN
      V_DESC := NVL(V_DESC, '') || ' ' || 'Hr Fim Vend. Prod. ' || '' || NVL(:NEW.HRFIMVENPROD, '');
    END IF;
    
      V_ITPESQ := :NEW.CDFILIAL||:NEW.CDTABEPREC||:NEW.DTINIVGPREC||:NEW.CDPRODUTO||:NEW.CDPRPAITABPR;
      V_IDTIPOOPER := '2';
   ELSE
      IF INSERTING THEN
      V_DESC   := 'Filial '               || '' || NVL(:NEW.CDFILIAL,''    )  || ' ' ||
                  'Tab Preco '            || '' || NVL(:NEW.CDTABEPREC,''  )  || ' ' ||
                  'Dt Ini Vg Preco '      || '' || NVL(:NEW.DTINIVGPREC,'' )  || ' ' ||
                  'Produto  '             || '' || NVL(:NEW.CDPRODUTO,''   )  || ' ' ||
                  'Cd Pai TAB Preco  '    || '' || NVL(:NEW.CDPRPAITABPR,'')  || ' ' ||
                  'Vr Preco Item  '       || '' || NVL(:NEW.VRPRECITEM,''  )  || ' ' ||
                  'Vr Preco Item Cli '    || '' || NVL(:NEW.VRPRECITEMCL,'')  || ' ' ||
                  'Vr Preco Max Item '    || '' || NVL(:NEW.VRPRECMAXITE,'')  || ' ' ||
                  'Id Preco Variado '     || '' || NVL(:NEW.IDPRECVARIA,'' )  || ' ' ||
                  'Vr Preco Sug Item '    || '' || NVL(:NEW.VRPRESUGITEM,'')  || ' ' ||
                  'Vr Custo Item  '       || '' || NVL(:NEW.VRCUSTITEM,''  )  || ' ' ||
                  'Vr Mkup Item  '        || '' || NVL(:NEW.VRMKUPITEM,''  )  || ' ' ||
                  'Id Prod Promocao  '    || '' || NVL(:NEW.IDPRODPROMOC,'')  || ' ' ||
                  'Dt Ult Atu Item Prod ' || '' || NVL(:NEW.DTULTATUITPR,'')  || ' ' ||
                  'Vr Delivery  '         || '' || NVL(:NEW.VRPRECITEMDLV,'') || ' ' ||
                  'Vr Comanda  '          || '' || NVL(:NEW.VRPRECITEMCMD,'') || ' ' ||
                  
                  'Existe Preco Site  '   || '' || NVL(:NEW.IDEXIPRECOSITE,'') || ' ' ||
                  'Produto Site  '        || '' || NVL(:NEW.IDEXIPRECOSITE,'') || ' ' ||
                  'Hr Ini. Vend. Prod. '  || '' || NVL(:NEW.HRINIVENPROD,'')   || ' ' ||
                  'Hr Fim Vend. Prod.  '  || '' || NVL(:NEW.HRFIMVENPROD,'');
                  
         V_ITPESQ := :NEW.CDFILIAL||:NEW.CDTABEPREC||:NEW.DTINIVGPREC||:NEW.CDPRODUTO||:NEW.CDPRPAITABPR;
         V_IDTIPOOPER := '1';
      ELSE
         IF DELETING THEN
      V_DESC   := 'Filial '               || '' || NVL(:OLD.CDFILIAL,''    )  || ' ' ||
                  'Tab Preco '            || '' || NVL(:OLD.CDTABEPREC,''  )  || ' ' ||
                  'Dt Ini Vg Preco '      || '' || NVL(:OLD.DTINIVGPREC,'' )  || ' ' ||
                  'Produto  '             || '' || NVL(:OLD.CDPRODUTO,''   )  || ' ' ||
                  'Cd Pai TAB Preco  '    || '' || NVL(:OLD.CDPRPAITABPR,'')  || ' ' ||
                  'Vr Preco Item  '       || '' || NVL(:OLD.VRPRECITEM,''  )  || ' ' ||
                  'Vr Preco Item Cli '    || '' || NVL(:OLD.VRPRECITEMCL,'')  || ' ' ||
                  'Vr Preco Max Item '    || '' || NVL(:OLD.VRPRECMAXITE,'')  || ' ' ||
                  'Id Preco Variado '     || '' || NVL(:OLD.IDPRECVARIA,'' )  || ' ' ||
                  'Vr Preco Sug Item '    || '' || NVL(:OLD.VRPRESUGITEM,'')  || ' ' ||
                  'Vr Custo Item  '       || '' || NVL(:OLD.VRCUSTITEM,''  )  || ' ' ||
                  'Vr Mkup Item  '        || '' || NVL(:OLD.VRMKUPITEM,''  )  || ' ' ||
                  'Id Prod Promocao  '    || '' || NVL(:OLD.IDPRODPROMOC,'')  || ' ' ||
                  'Dt Ult Atu Item Prod ' || '' || NVL(:OLD.DTULTATUITPR,'')  || ' ' ||
                  'Vr Delivery  '         || '' || NVL(:OLD.VRPRECITEMDLV,'') || ' ' ||
                  'Vr Comanda  '          || '' || NVL(:OLD.VRPRECITEMCMD,'') || ' ' ||

                  'Existe Preco Site  '   || '' || NVL(:OLD.IDEXIPRECOSITE,'') || ' ' ||
                  'Produto Site  '        || '' || NVL(:OLD.IDEXIPRECOSITE,'') || ' ' ||
                  'Hr Ini. Vend. Prod. '  || '' || NVL(:OLD.HRINIVENPROD,'')   || ' ' ||
                  'Hr Fim Vend. Prod.  '  || '' || NVL(:OLD.HRFIMVENPROD,'');
                  
            V_ITPESQ := :OLD.CDFILIAL||:OLD.CDTABEPREC||:OLD.DTINIVGPREC||:OLD.CDPRODUTO||:OLD.CDPRPAITABPR;
            V_IDTIPOOPER := '3';
         END IF;
      END IF;
   END IF;
   V_DESC := SUBSTR(V_DESC, 1, 4000);
   V_ITPESQ := SUBSTR(V_ITPESQ, 1, 40);
   INSERT INTO LOGOPERAVND
      (NMTABELAVND,
       DTOPERACAOVND,
       NMRESPOPERVND,
       IDTIPOOPERVND,
       DSOPERACAOVND,
       CDPESQITEMVND,
       DSRDMUSUOPERVND,
       DSENDUSUOPERVND,
       DSNMUSUOPERVND,
       DSMETUSUOPERVND,
       CDORESPOPERVND,
       CDFILLOGOPERVND)
   VALUES
      ('ITEMPRECO',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       NVL(V_DESC,' '),
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER,
       NVL(:NEW.CDFILIAL,:OLD.CDFILIAL));
END;
/